Differences between revisions 83 and 86 (spanning 3 versions)
Revision 83 as of 2014-02-28 08:36:45
Size: 12586
Editor: proxy04
Comment:
Revision 86 as of 2014-07-04 20:28:52
Size: 6142
Editor: ormaaj
Comment: Input validation for POSIX example.
Deletions are marked like this. Additions are marked like this.
Line 18: Line 18:
file="" file=
Line 21: Line 21:
while :
do
while :; do
Line 24: Line 23:
        -h | --help | -\?)
            # Call your Help() or usage() function here.
            exit 0 # This is not an error, User asked help. Don't do "exit 1"
        -h|-\?|--help) # Call a "show_help" function to display a synopsis, then exit.
            show_help
            exit
Line 28: Line 27:
        -f | --file)
            file=$2 # You might want to check if you really got FILE
            shift 2
        -f|--file) # Takes an option argument, ensuring it has been specified.
            if [ "$2" ]; then
                file=$2
                shift 2
                continue
            else
                echo 'ERROR: Must specify a non-empty "--file FILE" argument.' >&2
                exit 1
            fi
Line 32: Line 37:
        --file=*)
            file=${1#*=}        # Delete everything up till "="
        shift
        --file=?*)
            file=${1#*=} # Delete everything up to "=" and assign the remainder.
Line 36: Line 40:
        -v | --verbose)
            # Each instance of -v adds 1 to verbosity
            verbose=$((verbose+1))
            shift
        --file=) # Handle the case of an empty --file=
            echo 'ERROR: Must specify a non-empty "--file FILE" argument.' >&2
            exit 1
Line 41: Line 44:
        --) # End of all options         -v|--verbose)
            verbose=$((verbose + 1)) # Each -v argument adds 1 to verbosity.
            ;;
        --) # End of all options.
Line 45: Line 51:
        -*)
            echo "WARN: Unknown option (ignored): $1" >&2
            shift
        -?*)
            printf 'WARN: Unknown option (ignored): %s\n' "$1" >&2
Line 49: Line 54:
        *) # no more options. Stop while loop         *)              # Default case: If no more options then break out of the loop.
Line 51: Line 56:
            ;;
Line 53: Line 57:

    command shift
Line 55: Line 61:
# Suppose some options are required. Check that we got them.
# Suppose --file is a required option. Check that it has been set.
Line 58: Line 63:
    echo "ERROR: option '--file FILE' not given. See --help" >&2     echo 'ERROR: option "--file FILE" not given. See --help.' >&2
Line 66: Line 71:
Line 88: Line 94:
# Usage info
show_help() {
cat << EOF
Usage: ${0##*/} [-hv] [-f OUTFILE] [FILE]...
Do stuff with FILE and write the result to standard output. With no FILE
or when FILE is -, read standard input.
    
    -h display this help and exit
    -f OUTFILE write the result to OUTFILE instead of standard output.
    -v verbose mode. Can be used multiple times for increased
                verbosity.
EOF
}
Line 109: Line 129:
shift $((OPTIND-1)) # Shift off the options and optional --. shift "$((OPTIND-1))" # Shift off the options and optional --.
Line 111: Line 131:
echo "verbose=$verbose, output_file='$output_file', Leftovers: $@" printf 'verbose=<%s>\noutput_file=<%s>\nLeftovers:\n' "$verbose" "$output_file"
printf '<%s>\n' "$@"
Line 128: Line 149:
==== getopts long option trickery ====
Here is an example which claims to parse long options with `getopts`. The basic idea is quite simple: just put "-:" into the optstring. This trick requires a shell which permits the option-argument (i.e. the filename in "-f filename") to be concatenated to the option (as in "-ffilename") as POSIX requires. The [[http://pubs.opengroup.org/onlinepubs/9699919799/utilities/getopts.html|POSIX standard]] says you should pass arguments to options as separate options (to avoid problems with empty arguments) but requires `getopts` to handle the case where the argument is stuck to the option in the same argument. However, POSIX leaves the behaviour unspecified when an option is not alpha-numerical, so POSIX does not guarantee this to work. However, it should work in all of bash, dash, yash, zsh and all implementations of `ksh`, the only exception reported so far being `posh`.
Line 131: Line 150:


{{{#!highlight bash
#!/bin/bash
# Uses bash extensions. Not portable as written.

optspec=":h-:"

while getopts "$optspec" optchar
do
    case "${optchar}" in
        -)
            case "${OPTARG}" in
              loglevel)
                  eval val="\$${OPTIND}"; OPTIND=$(( $OPTIND + 1 ))
                  echo "Parsing option: '--${OPTARG}', value: '${val}'" >&2
                  ;;
              loglevel=*)
                  val=${OPTARG#*=}
                  opt=${OPTARG%=$val}
                  echo "Parsing option: '--${opt}', value: '${val}'" >&2
                  ;;
            esac
            ;;
        h)
            echo "usage: $0 [--loglevel[=]<value>]" >&2
            exit 2
            ;;
    esac
done

# End of file
}}}
In practice, this example is so obfuscated that it may be preferable to add concatenated option support (like `-vf filename`) to a manual parsing loop instead, if that was the only reason for using `getopts`.

Here's an improved and more generalized version of above attempt to add support for long options when using `getopts`:

{{{#!highlight bash
#!/bin/bash
# Uses bash extensions. Not portable as written.

declare -A longoptspec
longoptspec=( [loglevel]=1 ) #use associative array to declare how many arguments a long option expects, in this case we declare that loglevel expects/has one argument, long options that aren't listed in this way will have zero arguments by default
optspec=":h-:"
while getopts "$optspec" opt; do
while true; do
    case "${opt}" in
        -) #OPTARG is name-of-long-option or name-of-long-option=value
            if [[ "${OPTARG}" =~ .*=.* ]] #with this --key=value format only one argument is possible
            then
                opt=${OPTARG/=*/}
                OPTARG=${OPTARG#*=}
                ((OPTIND--))
            else #with this --key value1 value2 format multiple arguments are possible
                opt="$OPTARG"
                OPTARG=(${@:OPTIND:$((longoptspec[$opt]))})
            fi
            ((OPTIND+=longoptspec[$opt]))
            continue #now that opt/OPTARG are set we can process them as if getopts would've given us long options
            ;;
        loglevel)
          loglevel=$OPTARG
            ;;
        h|help)
            echo "usage: $0 [--loglevel[=]<value>]" >&2
            exit 2
            ;;
    esac
break; done
done

# End of file
}}}
With this version you can have long and short options side by side and you shouldn't need to modify the code from line 10 to 22. This solution can also handle multiple arguments for long options, just use ${OPTARG} or ${OPTARG[0]} for the first argument, ${OPTARG[1]} for the second argument, ${OPTARG[2]} for the third argument and so on. It has the same disadvantage of its predecessor in not being portable and specific to bash. Additionally, it breaks arguments with whitespace (line 18) for long options, when given using the syntax that does not include equal sign (=).

=== Silly repeated brute-force scanning ===
Another approach is to check options with `if` statements "on demand". A function like this one may be useful:

{{{#!highlight bash
#!/bin/bash

HaveOpt ()
{
    local needle=$1
    shift

    while [[ $1 == -* ]]
    do
        # By convention, "--" means end of options.
        case "$1" in
            --) return 1 ;;
            $needle) return 0 ;;
        esac

        shift
    done

    return 1
}

HaveOpt --quick "$@" && echo "Option quick is set"

# End of file
}}}
and it will work if script is run as:

 * YES: ./script --quick
 * YES: ./script -other --quick

but will stop on first argument with no "-" in front (or on --):

 * NO: ./script -bar foo --quick
 * NO: ./script -bar -- --quick

Of course, this approach (iterating over the argument list every time you want to check for one) is far less efficient than just iterating once and setting flag variables.

It also spreads the options throughout the program. The literal option `--quick` may appear a hundred lines down inside the main body of the program, nowhere near any other option name. This is a nightmare for maintenance.

=== Complex nonstandard add-on utilities ===
[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] suggests the use of [[http://sourceforge.net/projects/process-getopt/|process-getopt]] (GPL licensed) and offers this example code:

{{{
PROG=$(basename $0)
VERSION='1.2'
USAGE="A tiny example using process-getopt(1)"

# call process-getopt functions to define some options:
source process-getopt

SLOT=""
SLOT_func() { [ "${1:-""}" ] && SLOT="yes"; } # callback for SLOT option
add_opt SLOT "boolean option" s "" slot

TOKEN=""
TOKEN_func() { [ "${1:-""}" ] && TOKEN="$2"; } # callback for TOKEN option
add_opt TOKEN "this option takes a value" t n token number

add_std_opts # define the standard options --help etc:

TEMP=$(call_getopt "$@") || exit 1
eval set -- "$TEMP" # just as with getopt(1)

# remove the options from the command line
process_opts "$@" || shift "$?"

echo "SLOT=$SLOT"
echo "TOKEN=$TOKEN"
echo "args=$@"
}}}
Here, all information about each option is defined in one place making for much easier authoring and maintenance. A lot of the dirty work is handled automatically and standards are obeyed as in getopt(1) - because it calls getopt for you.

 . ''Actually, what the author forgot to say was that it's actually using `getopts` semantics, rather than `getopt`. I ran this test:''
 {{{
 ~/process-getopt-1.6$ set -- one 'rm -rf /' 'foo;bar' "'"
 ~/process-getopt-1.6$ call_getopt "$@"
  -- 'rm -rf /' 'foo;bar' ''\'''
}}}
 . ''It appears to be intelligent enough to handle null options, whitespace-containing options, and single-quote-containing options in a manner that makes the [[BashFAQ/048|eval]] not blow up in your face. But this is not an endorsement of the process-getopt software overall; I don't know it well enough. -GreyCat ''

''It's written and tested on Linux where getopt(1) supports long options. For portability, it tests the local getopt(1) at runtime and if it finds an non-GNU one (ie one that does not return 4 for {{{getopt --test}}}) it only processes short options. It does not use the bash builtin getopts(1) command. -[[http://bhepple.freeshell.org/oddmuse/wiki.cgi/process-getopt|bhepple]] ''
For other, more complicated ways of option parsing, see ComplexOptionParsing.

How can I handle command-line arguments (options) to my script easily?

Well, that depends a great deal on what you want to do with them. There are several approaches, each with its strengths and weaknesses.

Manual loop

This approach handles any arbitrary set of options, because you're writing the parser yourself. For 90% of programs, this is the simplest approach (because you rarely need fancy stuff).

This example will handle a combination of short and long options. Notice how both "--file" and "--file=FILE" are handled.

   1 #!/bin/sh
   2 # (POSIX shell syntax)
   3 
   4 # Reset all variables that might be set
   5 file=
   6 verbose=0
   7 
   8 while :; do
   9     case $1 in
  10         -h|-\?|--help)   # Call a "show_help" function to display a synopsis, then exit.
  11             show_help
  12             exit
  13             ;;
  14         -f|--file)       # Takes an option argument, ensuring it has been specified.
  15             if [ "$2" ]; then
  16                 file=$2
  17                 shift 2
  18                 continue
  19             else
  20                 echo 'ERROR: Must specify a non-empty "--file FILE" argument.' >&2
  21                 exit 1
  22             fi
  23             ;;
  24         --file=?*)
  25             file=${1#*=} # Delete everything up to "=" and assign the remainder.
  26             ;;
  27         --file=)         # Handle the case of an empty --file=
  28             echo 'ERROR: Must specify a non-empty "--file FILE" argument.' >&2
  29             exit 1
  30             ;;
  31         -v|--verbose)
  32             verbose=$((verbose + 1)) # Each -v argument adds 1 to verbosity.
  33             ;;
  34         --)              # End of all options.
  35             shift
  36             break
  37             ;;
  38         -?*)
  39             printf 'WARN: Unknown option (ignored): %s\n' "$1" >&2
  40             ;;
  41         *)               # Default case: If no more options then break out of the loop.
  42             break
  43     esac
  44 
  45     command shift
  46 done
  47 
  48 # Suppose --file is a required option. Check that it has been set.
  49 if [ ! "$file" ]; then
  50     echo 'ERROR: option "--file FILE" not given. See --help.' >&2
  51     exit 1
  52 fi
  53 
  54 # Rest of the program here.
  55 # If there are input files (for example) that follow the options, they
  56 # will remain in the "$@" positional parameters.

This parser does not handle separate options concatenated together (like -xvf being understood as -x -v -f). This could be added with effort, but this is left as an exercise for the reader.

Some Bash programmers like to write this at the beginning of their scripts to guard against unused variables:

    set -u     # or, set -o nounset

The use of this breaks the loop above, as "$1" may not be set upon entering the loop. There are four solutions to this issue:

  1. Stop using -u.

  2. Replace case $1 in with case ${1+$1} in (as well as bandaging all the other code that set -u breaks).

  3. Replace case $1 in with case ${1-} in (every potentially undeclared variable could be written as ${variable-} to prevent set -u tripping).

  4. Stop using -u.

getopts

Unless it's the version from util-linux, and you use its advanced mode, never use getopt(1). Traditional versions of getopt cannot handle empty argument strings, or arguments with embedded whitespace.

The POSIX shell (and others) offer getopts which is safe to use instead. Here is a simplistic getopts example:

   1 #!/bin/sh
   2 
   3 # Usage info
   4 show_help() {
   5 cat << EOF
   6 Usage: ${0##*/} [-hv] [-f OUTFILE] [FILE]...
   7 Do stuff with FILE and write the result to standard output. With no FILE
   8 or when FILE is -, read standard input.
   9     
  10     -h          display this help and exit
  11     -f OUTFILE  write the result to OUTFILE instead of standard output.
  12     -v          verbose mode. Can be used multiple times for increased
  13                 verbosity.
  14 EOF
  15 }                
  16 
  17 # Initialize our own variables:
  18 output_file=""
  19 verbose=0
  20 
  21 OPTIND=1 # Reset is necessary if getopts was used previously in the script.  It is a good idea to make this local in a function.
  22 while getopts "hvf:" opt; do
  23     case "$opt" in
  24         h)
  25             show_help
  26             exit 0
  27             ;;
  28         v)  verbose=1
  29             ;;
  30         f)  output_file=$OPTARG
  31             ;;
  32         '?')
  33             show_help >&2
  34             exit 1
  35             ;;
  36     esac
  37 done
  38 shift "$((OPTIND-1))" # Shift off the options and optional --.
  39 
  40 printf 'verbose=<%s>\noutput_file=<%s>\nLeftovers:\n' "$verbose" "$output_file"
  41 printf '<%s>\n' "$@"
  42 
  43 # End of file

The advantages of getopts are:

  1. It's portable, and will work in any POSIX shell e.g. dash.
  2. It can handle things like -vf filename in the expected Unix way, automatically.

  3. It understands -- as the option terminator and more generally makes sure, options are parsed like for any standard command.

  4. With some implementations, the error messages will be localised in the language of the user.

The disadvantage of getopts is that (except for ksh93 getopts) it can only handle short options (-h, not --help) without trickery and cannot handle options with optional arguments à la GNU.

There is a getopts tutorial which explains what all of the syntax and variables mean. In bash, there is also help getopts, which might be informative.

There is also still the disadvantage that options are coded in at least 2, probably 3 places - in the call to getopts, in the case statement that processes them and presumably in the help message that you are going to get around to writing one of these days. This is a classic opportunity for errors to creep in as the code is written and maintained - often not discovered till much, much later. This can be avoided by using callback functions, but this approach kind of defeats the purpose of using getopts at all.

For other, more complicated ways of option parsing, see ComplexOptionParsing.


CategoryShell

BashFAQ/035 (last edited 2024-02-26 07:51:38 by larryv)